local timerFrame = CreateFrame("Frame")
local DELAY = 20
local counter = 0
local origSetZoom = Minimap.SetZoom

function Minimap.SetZoom(...)
  -- Show the timer frame, starting the timer
  timerFrame:Show()
  counter = 0

  -- Call the original SetZoom function
  return origSetZoom(...)
end

local function OnUpdate(self, elapsed)
  -- Increment the counter variable
  counter = counter + elapsed

  if counter >= DELAY then
    -- Check current zoom level
    local z = Minimap:GetZoom()
    if z > 0 then
      origSetZoom(Minimap, z - 1)
    else
      -- Enable/Disable the buttons
      MinimapZoomIn:Enable()
      MinimapZoomOut:Disable()
      self:Hide()
    end
  end
end

timerFrame:SetScript("OnUpdate", OnUpdate)
if Minimap:GetZoom() == 0 then
  timerFrame:Hide()
end

